#
# duo-touch-sensor.py
#
# receive and display loading step response
# duo-touch-sensor.py serial_port
#
# Neil Gershenfeld
# CBA MIT 10/29/10
#
# (c) Massachusetts Institute of Technology 2010
# Permission granted for experimental and personal use;
# license for commercial sale available from MIT
#
# Changes added by Linda Wanders
# FabAcademy2014 - final project development 
# 4/28/14
#

from Tkinter import *
import serial
import time

WINDOW = 600 # window size
eps = 0.5 # filter time constant
filter1 = 0.0 # filtered value
filter2 = 0.0 # filtered value
filter3 = 0.0 # filtered value
filter4 = 0.0 # filtered value
filter5 = 0.0 # filtered value
filter6 = 0.0 # filtered value

old_time = time.time()

def idle(parent,canvas):
   
   # global var
   global old_time 
   
   # idle routine
   byte2 = 0
   byte3 = 0
   byte4 = 0
   ser.flush()
   
   # find framing 
   while 1:
      byte1 = byte2
      byte2 = byte3
      byte3 = byte4
      byte4 = ord(ser.read())
      if ((byte1 == 1) & (byte2 == 2) & (byte3 == 3) & (byte4 == 4)):
         break
  
   # verschil tijd vorige aanroep berekenen
   new_time = time.time()
   verschil = old_time - new_time
   old_time = new_time
   
   print verschil

   #
   # read and plot
   #
   adc0_avg1_high = ord(ser.read())
   adc0_avg1_low = ord(ser.read())
   
   adc0_avg2_high = ord(ser.read())
   adc0_avg2_low = ord(ser.read())
   
   adc0_avg3_high = ord(ser.read())
   adc0_avg3_low = ord(ser.read())
   
   adc1_avg1_high = ord(ser.read())
   adc1_avg1_low = ord(ser.read())
   
   adc1_avg2_high = ord(ser.read())
   adc1_avg2_low = ord(ser.read())
   
   adc1_avg3_high = ord(ser.read())
   adc1_avg3_low = ord(ser.read())
   
   filter1 = 256*adc0_avg1_high + adc0_avg1_low
   filter2 = 256*adc0_avg2_high + adc0_avg2_low
   filter3 = 256*adc0_avg3_high + adc0_avg3_low
   filter4 = 256*adc1_avg1_high + adc1_avg1_low
   filter5 = 256*adc1_avg2_high + adc1_avg2_low
   filter6 = 256*adc1_avg3_high + adc1_avg3_low
   
   x1 = int(.2*WINDOW + (.9-.2)*WINDOW*filter1/1023.0)
   x2 = int(.2*WINDOW + (.9-.2)*WINDOW*filter2/1023.0)
   x3 = int(.2*WINDOW + (.9-.2)*WINDOW*filter3/1023.0)
   x4 = int(.2*WINDOW + (.9-.2)*WINDOW*filter4/1023.0)   
   x5 = int(.2*WINDOW + (.9-.2)*WINDOW*filter5/1023.0)
   x6 = int(.2*WINDOW + (.9-.2)*WINDOW*filter6/1023.0)
   
   canvas.itemconfigure("text1",text="%.1f"%filter1)
   canvas.itemconfigure("text2",text="%.1f"%filter2)
   canvas.itemconfigure("text3",text="%.1f"%filter3)
   canvas.itemconfigure("text4",text="%.1f"%filter4) 
   canvas.itemconfigure("text5",text="%.1f"%filter5)
   canvas.itemconfigure("text6",text="%.1f"%filter6)  
   
   canvas.coords('rect11',.2*WINDOW,.05*WINDOW,x1,.1*WINDOW)
   canvas.coords('rect12',x1,.05*WINDOW,.9*WINDOW,.1*WINDOW)
   
   canvas.coords('rect21',.2*WINDOW,.15*WINDOW,x2,.20*WINDOW) 
   canvas.coords('rect22',x2,.15*WINDOW,.9*WINDOW,.20*WINDOW)
   
   canvas.coords('rect31',.2*WINDOW,.25*WINDOW,x3,.30*WINDOW)
   canvas.coords('rect32',x3,.25*WINDOW,.9*WINDOW,.30*WINDOW)
   
   canvas.coords('rect41',.2*WINDOW,.45*WINDOW,x4,.50*WINDOW)
   canvas.coords('rect42',x4,.45*WINDOW,.9*WINDOW,.50*WINDOW)
   
   canvas.coords('rect51',.2*WINDOW,.55*WINDOW,x5,.60*WINDOW)
   canvas.coords('rect52',x5,.55*WINDOW,.9*WINDOW,.60*WINDOW)
   
   canvas.coords('rect61',.2*WINDOW,.65*WINDOW,x6,.70*WINDOW)
   canvas.coords('rect62',x6,.65*WINDOW,.9*WINDOW,.70*WINDOW)
   
   canvas.update()
   parent.after_idle(idle,parent,canvas)

#
#  check command line arguments
#
if (len(sys.argv) != 2):
   print "command line: hello.load.45.py serial_port"
   sys.exit()
port = sys.argv[1]
#
# open serial port
#
ser = serial.Serial(port,9600)
ser.setDTR()
#
# set up GUI
#
root = Tk()
root.title('hello.load.45.py (q to exit)')
root.bind('q','exit')
canvas = Canvas(root, width=WINDOW, height=.75*WINDOW, background='white')
#
canvas.create_text(.1*WINDOW,.075*WINDOW,text="1",font=("Helvetica", 24),tags="text1",fill="#2c2c2c")
canvas.create_rectangle(.2*WINDOW,.05*WINDOW,.3*WINDOW,.1*WINDOW, tags='rect11', fill='#b00000')
canvas.create_rectangle(.3*WINDOW,.05*WINDOW,.9*WINDOW,.1*WINDOW, tags='rect12', fill='#eaf718')
#
canvas.create_text(.1*WINDOW,.175*WINDOW,text="2",font=("Helvetica", 24),tags="text2",fill="#2c2c2c")
canvas.create_rectangle(.2*WINDOW,.15*WINDOW,.3*WINDOW,.20*WINDOW, tags='rect21', fill='#b00000')
canvas.create_rectangle(.3*WINDOW,.15*WINDOW,.9*WINDOW,.20*WINDOW, tags='rect22', fill='#eaf718')
#
canvas.create_text(.1*WINDOW,.275*WINDOW,text="3",font=("Helvetica", 24),tags="text3",fill="#2c2c2c")
canvas.create_rectangle(.2*WINDOW,.25*WINDOW,.3*WINDOW,.30*WINDOW, tags='rect31', fill='#b00000')
canvas.create_rectangle(.3*WINDOW,.25*WINDOW,.9*WINDOW,.30*WINDOW, tags='rect32', fill='#eaf718')
#
canvas.create_text(.1*WINDOW,.475*WINDOW,text="4",font=("Helvetica", 24),tags="text4",fill="#2c2c2c")
canvas.create_rectangle(.2*WINDOW,.45*WINDOW,.3*WINDOW,.50*WINDOW, tags='rect41', fill='#002363')
canvas.create_rectangle(.3*WINDOW,.45*WINDOW,.9*WINDOW,.50*WINDOW, tags='rect42', fill='#36bf00')
#
canvas.create_text(.1*WINDOW,.575*WINDOW,text="5",font=("Helvetica", 24),tags="text5",fill="#2c2c2c")
canvas.create_rectangle(.2*WINDOW,.55*WINDOW,.3*WINDOW,.60*WINDOW, tags='rect51', fill='#002363')
canvas.create_rectangle(.3*WINDOW,.55*WINDOW,.9*WINDOW,.60*WINDOW, tags='rect52', fill='#36bf00')
#
canvas.create_text(.1*WINDOW,.675*WINDOW,text="6",font=("Helvetica", 24),tags="text6",fill="#2c2c2c")
canvas.create_rectangle(.2*WINDOW,.65*WINDOW,.3*WINDOW,.70*WINDOW, tags='rect61', fill='#002363')
canvas.create_rectangle(.3*WINDOW,.65*WINDOW,.9*WINDOW,.70*WINDOW, tags='rect62', fill='#36bf00')

canvas.pack()
#
# start idle loop
#
root.after(100,idle,root,canvas)
root.mainloop()
